#ifndef CameraDrivingPerceptionOneSubDataWrapper_WRAPPER_HEADER_H
#define CameraDrivingPerceptionOneSubDataWrapper_WRAPPER_HEADER_H

#include <random>
#include <fstream>

#include "sub/SubDataWrapper.h"
#include "MbufModule.h"

template <typename DataType>
class CamDrv2CamDrvPerception_SubDataWrapper : public SubDataWrapper<DataType>
{
public:
    void Process(ara::com::SamplePtr<DataType const> *ptr) override
    {
        // // test mbuf with string value
        // // auto sample = ptr->Get();
        // // Mbuf *pMbuf = reinterpret_cast<Mbuf *>(sample->GetMbufPtr());
        // // uint64_t size;
        // // uint8_t *pData = mbuf::MbufModule::GetInstance().getMbufData(&pMbuf, &size);
        // // for (uint8_t i=0; i < sample->dataSize; i++)
        // // {
        // //     printf("%c", pData[i]);
        // // }
        // // printf("\n");

        // // test mbuf with bgr value
        // std::lock_guard<std::mutex> lock(this->m_writer_mutex);
        // if (this->firstTime)
        // {
        //     std::random_device rd;
        //     std::default_random_engine gen(rd());
        //     std::uniform_int_distribution<> dis(1, 800);
        //     this->randomNum = dis(gen);
        //     this->firstTime = false;
        // }
        // auto sample = ptr->Get();
        // Mbuf *pMbuf = reinterpret_cast<Mbuf *>(sample->GetMbufPtr());
        // uint64_t size;
        // uint8_t *pData = mbuf::MbufModule::GetInstance().getMbufData(&pMbuf, &size);
        // if (this->counter++ == this->randomNum || this->writeData)
        // {
        //     this->writeData = true;
        //     if (!this->recorded[sample->cameraId - 1])
        //     {
        //         std::ofstream outFile((this->fileName + "test_" + std::to_string(this->randomNum) + "_" + std::to_string(sample->cameraId) + ".bgr"), std::ios::binary);
        //         if (!outFile)
        //         {
        //             return;
        //         }
        //         outFile.write(reinterpret_cast<char *>(pData), sample->dataSize);
        //         outFile.close();
        //         std::cout << "camera " << sample->cameraId << " size: " << sample->dataSize << std::endl;
        //         this->recorded[sample->cameraId - 1] = true;
        //         this->writeData = !(this->recorded[0] && this->recorded[1] && this->recorded[2] && this->recorded[3]);
        //     }
        // }
        auto sample = ptr->Get();
        Mbuf *pMbuf = reinterpret_cast<Mbuf *>(sample->GetMbufPtr());
        uint64_t size;
        uint8_t *pData = MbufManager.getMbufData(&pMbuf, &size);
        // std::cout<<"Received data from Camera Driving is: "<<static_cast<int>(sample->cameraId)<<std::endl;
    }

private:
    mbuf::MbufModule MbufManager;
    // bool recorded[4] = { false };
    // bool writeData = false;
    // std::mutex m_writer_mutex;
    // bool firstTime = true;
    // int randomNum;
    // int counter = 0;
    // std::string fileName = "/opt/usr/home/mdc/salehian/images/";
};
template <typename DataType>
class Slam2DrvPerceptionOdom_SubDataWrapper : public SubDataWrapper<DataType>
{
public:
    void Process(ara::com::SamplePtr<DataType const> *ptr) override
    {
        auto sample = ptr->Get();
        // std::cout<<"Received data from SLAM is: "<<sample->utc_timestamp<<std::endl;
    }

private:

};

template <typename DataType>
class CAN2DrvPerception_SubDataWrapper : public SubDataWrapper<DataType>
{
public:
    void Process(ara::com::SamplePtr<DataType const> *ptr) override
    {
        auto sample = ptr->Get();
        // std::cout<<"Received data from CAN is: "<<sample->VCU_Info_1_Signals.ses_en_sts<<std::endl;
    }

private:

};

template <typename DataType>
class VED2DrvPerception_SubDataWrapper : public SubDataWrapper<DataType>
{
public:
    void Process(ara::com::SamplePtr<DataType const> *ptr) override
    {
        auto sample = ptr->Get();
        // std::cout<<"Received data from VED is: "<<sample->LongAcc<<std::endl;
    }

private:

};
#endif /* CameraDrivingPerceptionOneSubDataWrapper_WRAPPER_HEADER_H */
